Index: /trunk/LMDZ.GENERIC/deftank/saturn1d/callphys.def
===================================================================
--- /trunk/LMDZ.GENERIC/deftank/saturn1d/callphys.def	(revision 976)
+++ /trunk/LMDZ.GENERIC/deftank/saturn1d/callphys.def	(revision 976)
@@ -0,0 +1,170 @@
+## Orbit / general options
+## ~~~~~~~~~~~~~~~~~~~~~~~
+# Run with or without tracer transport ?
+tracer    = .false.
+# Diurnal cycle ?  if diurnal=false, diurnally averaged solar heating
+diurnal   = .false. #.true.
+# Seasonal cycle ? if season=false, Ls stays constant, to value set in "start"
+season    = .false.
+# Tidally resonant orbit ? must have diurnal=false, correct rotation rate in newstart
+tlocked   = .false.
+# Tidal resonance ratio ? ratio T_orbit to T_rotation
+nres      = 1
+# Write some more output on the screen ?
+lwrite    = .false.
+# Save statistics in file "stats.nc" ?
+callstats = .false.
+# Test energy conservation of model physics ?
+enertest  = .true.
+# Check to see if cpp, mugaz values used match gas mixture defined in gases.def (recommended) ?
+check_cpp_match=.false. 
+
+## Directory where external input files are
+## ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#datadir     = /san/home/spiga/DATAGENERIC
+#datadir      = /san/home/spiga/COMMON/DATAGENERIC/
+#datadir     = /home/spiga/datagcm
+datadir = /d5/aslmd/datagcm/
+
+## Radiative transfer options
+## ~~~~~~~~~~~~~~~~~~~~~~~~~~
+# call radiative transfer?
+callrad    = .true.
+# the rad. transfer is computed every "iradia" physical timestep
+iradia     = 120 180 60 20 1 160
+# call multilayer correlated-k radiative transfer ?
+corrk      = .true.
+# Include continuum absorption in radiative transfer (note CO2 is treated separately) ?
+continuum  = .true.
+# folder in which correlated-k data is stored ?
+corrkdir   = CH4_C2H6_C2H2_Profils
+corrkdir   = CH4_C2H6_C2H2_T_70-400K
+# call visible gaseous absorption in radiative transfer ?
+callgasvis = .true.
+# Include Rayleigh scattering in the visible ?
+rayleigh   = .true.
+# Uniform absorption coefficient in radiative transfer?
+graybody     = .false.
+# Characteristic planetary equilibrium (black body) temperature
+# This is used only in the aerosol radiative transfer setup. (see aerave.F)
+tplanet    = 215.
+# Output spectral OLR in 1D/3D?
+specOLR    = .false.
+# Output global radiative balance in file 'rad_bal.out' - slow for 1D!!
+meanOLR    = .false.
+# Variable gas species: Radiatively active ?
+varactive  = .false.
+# Variable gas species: Fixed vertical distribution ?
+#   (not to be used in time integration mode)
+varfixed   = .false.
+# Variable gas species: Saturation percentage value at ground ?
+satval     = 0.0
+# Force specific heat capacity and molecular mass values
+force_cpp      = .false.
+# Specific heat capacity in J K-1 kg-1 [only used if force_cpp = T]
+cpp            = 14000.
+# Molecular mass in g mol-1 [only used if force_cpp = T]
+mugaz          = 2.14
+
+## Star type
+## ~~~~~~~~~
+startype = 1
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# The choices are:
+#
+#	startype = 1		Sol        (G2V-class main sequence)
+#	startype = 2		Ad Leo     (M-class, synthetic)
+#       startype = 3            GJ644
+#       startype = 4            HD128167
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# Stellar flux at 1 AU. Examples:
+# 1366.0 W m-2		Sol today
+# 1024.5 W m-2		Sol today x 0.75 = weak early Sun
+# 18.462 W m-2		The feeble Gl581
+# 19.960 W m-2		Gl581 with e=0.38 orbital average
+Fat1AU = 1366.0
+
+## Tracer and aerosol options 
+## ~~~~~~~~~~~~~~~~~~~~~~~~~~
+# Gravitational sedimentation of tracers (just H2O ice for now) ?
+sedimentation = .false.
+
+## Other physics options
+## ~~~~~~~~~~~~~~~~~~~~~
+# call turbulent vertical diffusion ?
+calldifv = .true. 
+# use turbdiff instead of vdifc ?
+UseTurbDiff = .true.
+# call convective adjustment ?
+calladj  = .true.
+# call thermal conduction in the soil ?
+callsoil = .false.
+# Internal heat flux (matters only if callsoil=F)
+intheat = 2.0
+# Remove lower boundary (e.g. for gas giant sims)
+nosurf = .true.
+
+#########################################################################
+## extra non-standard definitions for Earth
+#########################################################################
+ 
+## Tracer and aerosol options 
+## ~~~~~~~~~~~~~~~~~~~~~~~~~~
+# Radiatively active CO2 aerosol?
+aeroco2       = .false.
+# Fixed CO2 aerosol distribution?
+aerofixco2    = .false.
+# Radiatively active water aerosol?
+aeroh2o       = .false.
+# Fixed water aerosol distribution?
+aerofixh2o    = .false.
+# basic dust opacity
+dusttau       = 0.0
+# Varying H2O cloud fraction?
+CLFvarying    = .false.
+# H2O cloud fraction if fixed?
+CLFfixval     = 0.0
+# fixed radii for cloud particles?
+radfixed=.false.
+# number mixing ratio of CO2 ice particles
+Nmix_co2      = 100000.
+# number mixing ratio of water particles (for rafixed=.false.)
+Nmix_h2o      = 1.e7
+# number mixing ratio of water ice particles (for rafixed=.false.)
+Nmix_h2o_ice  = 5.e5
+# radius of H2O water particles (for rafixed=.true.):
+rad_h2o=10.e-6
+# radius of H2O ice particles (for rafixed=.true.):
+rad_h2o_ice=35.e-6
+# atm mass update due to tracer evaporation/condensation?
+mass_redistrib = .false.
+
+## Water options 
+## ~~~~~~~~~~~~~
+# Model water cycle
+water         = .false.
+# Model water cloud formation
+watercond     = .false.
+# Model water precipitation (including coagulation etc.)
+waterrain     = .false.
+# Use simple precipitation scheme?
+precip_scheme=4
+# multiplicative constant in Boucher 95 precip scheme
+Cboucher=1.
+# Include hydrology ?
+hydrology     = .false.
+# H2O snow (and ice) albedo ?
+albedosnow    = 0.6
+# Maximum sea ice thickness ?
+maxicethick   = 10.
+# Freezing point of seawater (degrees C) ?
+Tsaldiff      = 0.0
+# Evolve surface water sources ?
+sourceevol    = .false.
+
+## CO2 options 
+## ~~~~~~~~~~~
+# call CO2 condensation ?
+co2cond       = .false.
+# Set initial temperature profile to 1 K above CO2 condensation everywhere?
+nearco2cond   = .false.
Index: /trunk/LMDZ.GENERIC/deftank/saturn1d/compile
===================================================================
--- /trunk/LMDZ.GENERIC/deftank/saturn1d/compile	(revision 976)
+++ /trunk/LMDZ.GENERIC/deftank/saturn1d/compile	(revision 976)
@@ -0,0 +1,3 @@
+#! /bin/bash
+
+/donnees/aslmd/MODELES/LMDZ.GENERIC/makegcm -d 32 -t 0 -b 38x36 rcm1d
Index: /trunk/LMDZ.GENERIC/deftank/saturn1d/gases.def
===================================================================
--- /trunk/LMDZ.GENERIC/deftank/saturn1d/gases.def	(revision 976)
+++ /trunk/LMDZ.GENERIC/deftank/saturn1d/gases.def	(revision 976)
@@ -0,0 +1,17 @@
+# gases
+5
+H2_
+He_
+CH4
+C2H2
+C2H6
+0.85
+0.1455
+0.0045
+1.e-7
+1.e-5
+# First line is number of gases
+# Followed by gas names (always 3 characters)
+# and then molar mixing ratios.
+# mixing ratio -1 means the gas is variable.
+
Index: /trunk/LMDZ.GENERIC/deftank/saturn1d/rcm1d.def
===================================================================
--- /trunk/LMDZ.GENERIC/deftank/saturn1d/rcm1d.def	(revision 976)
+++ /trunk/LMDZ.GENERIC/deftank/saturn1d/rcm1d.def	(revision 976)
@@ -0,0 +1,101 @@
+#---------------------------------#
+# Run parameters for the 1D model #                                         
+#---------------------------------#
+
+## Planetary constants
+## ~~~~~~~~~~~~~~~~~~~~~~~
+## NB: those are mandatory
+## ~~~~~~~~~~~~~~~~~~~~~~~
+## LENGTH OF A DAY in s
+#daysec         = 38362. # Voyager System III
+#daysec         = 38640. # Cassini System IIIa
+daysec         = 38052. # Read System IIIw
+## GRAVITY in m s-2
+g              = 10.44
+## LENGTH OF A YEAR in days
+#year_day       = 24232. # Voyager System III
+#year_day       = 24058. # Cassini System IIIa
+year_day       = 24430. # Read System IIIw
+## MIN DIST STAR-PLANET in AU [periastron]
+periastr       = 9.04
+## MAX DIST STAR-PLANET in AU [apoastron]
+apoastr        = 10.12
+## DATE OF PERIASTRON in days
+peri_day       = 18700.
+## OBLIQUITY in deg
+obliquit       = 26.73
+## SURFACE PRESSURE in Pa
+psurf          = 1.e6
+
+## Time integration parameters
+## ~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# Initial date (in solar days,=0 at Ls=0)
+day0           = 0
+# Initial local time (in hours, between 0 and 24)
+time           = 12 
+# Number of time steps per sol
+day_step       = 1
+# Number of sols to run 
+ndt            = 293160
+# Number of steps between each writing in diagfi
+ecritphy=5000
+
+
+## Vertical levels
+## ~~~~~~~~~~~~~~~
+# hybrid vertical coordinate ? (.true. for hybrid and .false. for sigma levels)
+hybrid         = .false.
+# autocompute vertical discretisation? (useful for exoplanet runs)
+autozlevs      = .true.
+autozlevs      = .false.
+# Ceiling pressure (Pa) ? (only used if autozlevs = .true.)
+pceil          = 10.
+
+## Thermal properties
+## ~~~~~~~~~~~~~~~~~~
+# Simulate global averaged conditions ? 
+global1d       = .true.
+# Latitude (deg) [only used if global1d = F]
+latitude       = 0.0
+# Solar Zenith angle (deg) [only used if global1d = T]
+szangle        = 45. 
+# Albedo of bare ground
+albedo         = 0.0
+# Emissivity of bare ground
+emis           = 1.0
+# Soil thermal inertia (SI)
+inertia        = 0.001
+# Initial CO2 ice on the surface (kg.m-2)
+co2ice         = 0.
+
+## Wind profile
+## ~~~~~~~~~~~~
+## zonal eastward component of the geostrophic wind (m/s)
+u              = 0.
+# meridional northward component of the geostrophic wind (m/s)
+v              = 0.
+
+## Initial atmospheric temperature profile
+## ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+# Type of initial temperature profile
+#         ichoice=1   Constant Temperature:  T=tref
+#         [Mars] ichoice=2   Savidjari profile (as Seiff but with dT/dz=cte)
+#         [Mars] ichoice=3   Lindner (polar profile)
+#         [Mars] ichoice=4   inversion
+#         [Mars] ichoice=5   Seiff  (standard profile, based on Viking entry)
+#         ichoice=6   constant T  +  gaussian perturbation (levels)
+#         ichoice=7   constant T  + gaussian perturbation (km)
+#         ichoice=8   Read in an ascii file "profile" 
+ichoice        = 1
+# Reference temperature tref (K)
+tref           = 200.
+# Add a perturbation to profile if isin=1
+isin           = 0
+# peak of gaussian perturbation (for ichoice=6 or 7)
+pic            = 26.522
+# width of the gaussian perturbation (for ichoice=6 or 7)
+largeur        = 10
+# height of the gaussian perturbation (for ichoice=6 or 7)
+hauteur        = 30.
+
Index: /trunk/LMDZ.GENERIC/deftank/saturn1d/traceur.def
===================================================================
--- /trunk/LMDZ.GENERIC/deftank/saturn1d/traceur.def	(revision 976)
+++ /trunk/LMDZ.GENERIC/deftank/saturn1d/traceur.def	(revision 976)
@@ -0,0 +1,2 @@
+0
+dummy
Index: /trunk/LMDZ.GENERIC/deftank/saturn1d/z2sig.def
===================================================================
--- /trunk/LMDZ.GENERIC/deftank/saturn1d/z2sig.def	(revision 976)
+++ /trunk/LMDZ.GENERIC/deftank/saturn1d/z2sig.def	(revision 976)
@@ -0,0 +1,33 @@
+50.000
+25.0
+50.0
+75.0
+100.0
+125.0
+150.0
+175.0
+200.0
+225.0
+250.0
+275.0
+300.0
+325.0
+350.0
+375.0
+400.0
+425.0
+450.0
+475.0
+500.0
+525.0
+550.0
+575.0
+600.0
+625.0
+650.0
+675.0
+700.0
+725.0
+750.0
+775.0
+800.0